/*
 * Copyright (c) 2017 Digital Bazaar, Inc. All rights reserved.
 */
'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var _require = require('./util'),
    callbackify = _require.callbackify,
    normalizeDocumentLoader = _require.normalizeDocumentLoader;

module.exports = function () {
  /**
   * Creates a simple queue for requesting documents.
   */
  function RequestQueue() {
    _classCallCheck(this, RequestQueue);

    this._requests = {};
    this.add = callbackify(this.add.bind(this));
  }

  _createClass(RequestQueue, [{
    key: 'wrapLoader',
    value: function wrapLoader(loader) {
      var self = this;
      self._loader = normalizeDocumentLoader(loader);
      return function () /* url */{
        return self.add.apply(self, arguments);
      };
    }
  }, {
    key: 'add',
    value: function () {
      var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(url) {
        var self, promise;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                self = this;
                promise = self._requests[url];

                if (!promise) {
                  _context.next = 4;
                  break;
                }

                return _context.abrupt('return', Promise.resolve(promise));

              case 4:

                // queue URL and load it
                promise = self._requests[url] = self._loader(url);

                _context.prev = 5;
                _context.next = 8;
                return promise;

              case 8:
                return _context.abrupt('return', _context.sent);

              case 9:
                _context.prev = 9;

                delete self._requests[url];
                return _context.finish(9);

              case 12:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this, [[5,, 9, 12]]);
      }));

      function add(_x) {
        return _ref.apply(this, arguments);
      }

      return add;
    }()
  }]);

  return RequestQueue;
}();